ENV['RACK_ENV'] = "test"

require_relative '../lib/delinquo'
require 'rspec'
require 'rack/test'
require 'capybara/rspec'

ActiveRecord::Base.logger = nil
I18n.enforce_available_locales = false

Capybara.app = Delinquo::App

def app
  Delinquo::App
end

RSpec.configure do |conf|
  conf.include Rack::Test::Methods
  conf.include Capybara::DSL
  conf.before(:all) do
    puts "\nCurrrent Database: " + ActiveRecord::Base.connection.instance_variable_get(:@config)[:database]
  end
end

def check_status(code)
  last_response.status.should == code
end

def json_for_a_run_with_two_fails
  {
    total: '500',
    fails: [
      { feature: "a feature", scenario: "a scenario", step: "a step", line: "a line"},
      { feature: "a feature", scenario: "a scenario", step: "a step", line: "a line"}
    ]
  }.to_json
end

def json_for_a_passing_run
  {
    total: '500',
    fails: []
  }.to_json
end


def json_for_a_run_with_a_top_fail
   {
    total: '500',
    fails: [
      { feature: "a feature", scenario: "a scenario", step: "a step", line: "this is the most fequently failing test"},
      { feature: "a feature", scenario: "a scenario", step: "a step", line: "this is the most fequently failing test"},
      { feature: "a feature", scenario: "a scenario", step: "a step", line: "this is the most fequently failing test"},
      { feature: "a feature", scenario: "a scenario", step: "a step", line: "this is the most fequently failing test"},
      { feature: "a feature", scenario: "a scenario", step: "a step", line: "this is the most fequently failing test"}
    ]
  }.to_json
end

def add_runs_with_a_top_fail
  2.times do
    post '/project/delinquo/run', json_for_a_run_with_two_fails 
    check_status 201
  end
  post '/project/delinquo/run', json_for_a_run_with_a_top_fail
  check_status 201
end


def add_runs(number=2,state='failing')
  number.times do
    post '/project/delinquo/run', (state == 'failing')? json_for_a_run_with_two_fails : json_for_a_passing_run
    check_status 201
  end
end

def add_run(state='failing')
  post '/project/delinquo/run', (state == 'failing')? json_for_a_run_with_two_fails : json_for_a_passing_run
  check_status 201
end